<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/

/*---------------------------------------------------+
| tree_navigation_panel
+----------------------------------------------------+
| Copyright  2006 DennisSystems Ltd
| http://www.dennissystems.net
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/

require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";

$class_path   = INFUSIONS . "tree_navigation_panel/HTML_TreeMenu-1.2.0";
require_once  "$class_path/TreeMenu.php";
$image_path   = "$class_path/images";
$allowed_file_types = array(".gif",".png",".jpg",".jpeg");
$ignored_images = array('branch.gif','branchbottom.gif', 'branchtop.gif', 'line.gif', 'linebottom.gif', 'minus.gif', 'minusbottom.gif', 'minustop.gif', 'plus.gif', 'plusbottom.gif', 'plustop.gif', 'add.gif');

if (!checkrights("IP")) fallback("../index.php");
// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS . "tree_navigation_panel/locale/" . $settings['locale'] . ".php")) {
    // Load the locale file matching the current site locale setting.
    include INFUSIONS . "tree_navigation_panel/locale/" . $settings['locale'] . ".php";
} else {
    // Load the infusion's default locale file.
    include INFUSIONS . "tree_navigation_panel/locale/English.php";
} 


echo "<script src='$class_path/TreeMenu.js' language='JavaScript' type='text/javascript'></script>";
echo "<script LANGUAGE=\"JavaScript\">
        <!--
        function confirmation(item, message) {
             var answer = confirm(message + ':\\n' + item);
             if (answer){
                 return true;
             }
             else{
                 return false;
             }
        }
        //-->
        
        </script>";
        
opentable($locale['tnp200']);

if (isset($action) && $action == "delete_node"){
	function deleteRecursive($id){
	  global $db_prefix;
		$result = dbquery("SELECT * FROM " . DB_PREFIX . "tree_navigation_panel WHERE node_parent = $id");
		while($data = dbarray($result)) {
	           deleteRecursive($data['node_id']);
		}
		$result = dbquery("DELETE FROM " .  DB_PREFIX . "tree_navigation_panel WHERE node_id='$id'");
	}
	deleteRecursive($node_id);
}
if (isset($action) && $action == "save_node"){
    if (!empty($_POST['node_name'])){
	   $node_name = $_POST['node_name'];
	}else{  
		$err_msg = 'tnp231';
	}
    $node_url = $_POST['node_url'];
	$node_visibility = isNum($_POST['node_visibility']) ? $_POST['node_visibility'] : "0";
    $open_img = $_POST['open_img'];
    $closed_img = $_POST['closed_img'];    
    $node_open = isset($_POST['node_open']) && isNum($_POST['node_open']) ? $_POST['node_open'] : "0";	
    $node_parent = $_POST['node_parent']; 	   
    if (isset($node_id) && isNum($node_id)){
        $result = dbquery("UPDATE " .  DB_PREFIX . "tree_navigation_panel SET node_name='$node_name', node_url='$node_url', node_visibility='$node_visibility', open_img='$open_img', closed_img='$closed_img', node_open = '$node_open', node_parent='$node_parent', node_position='$node_position' WHERE node_id='$node_id'");
    }else{
    	$result = dbquery("INSERT INTO " .  DB_PREFIX . "tree_navigation_panel ( node_name, node_url, node_visibility, open_img, closed_img, node_open, node_parent, node_position) VALUES ('$node_name', '$node_url', '$node_visibility', '$open_img', '$closed_img', '$node_open', '$node_parent', '$node_position')");
    }
    if ($result){
		redirect(FUSION_SELF);
	}else{
		$err_msg = 'tnp233';
	}
	if (isset($err_msg)){
	    opentable($locale['tnp230']);
        echo "<div align='center'><b>" . $locale[$err_msg] . "</b><br>\n";
		echo "<input type=button value='".$locale['tnp221'] ."' onClick='history.go(-1)' class='button'></div>";
        closetable();
        tablebreak();
        exit;
	}	
}elseif (isset($action) && $action == "add_node" || isset($action) && $action == "edit_node"){
    if (isset($node_id) && isNum($node_id)){
    	$data = dbarray(dbquery("SELECT * FROM " .  DB_PREFIX . "tree_navigation_panel WHERE node_id = $node_id"));
		$node_name = $data['node_name'];
		$node_url = $data['node_url'];
		$node_visibility = $data['node_visibility'];
		$open_img = $data['open_img'];
		$closed_img = $data['closed_img'];		
		$node_open = $data['node_open'];
		$node_parent = $data['node_parent'];
				$node_position = $data['node_position'];
      	$formaction = FUSION_SELF."?action=save_node&node_id=".$data['node_id'];
	}else{
	  	$formaction = FUSION_SELF."?action=save_node";
		$node_name = '';
		$node_url = '';
		$node_visibility = '';
		$open_img = 'folder.gif';		
		$closed_img = 'folder-expanded.gif';
		$node_open ='1';

	}

    if (!isset($node_parent)) $node_parent = '0';	  
	if (!isset($node_position)) $node_position = '1';

	$user_groups = getusergroups();
	$access_opts = "";
	$sel = "";
	while (list ($key, $user_group) = each($user_groups)) {
	    if (isset($node_visibility)) $sel = ($node_visibility == $user_group['0'] ? " selected" : "");
	    $access_opts .= "<option value='" . $user_group['0'] . "'$sel>" . $user_group['1'] . "</option>\n";
	} 
	$temp = opendir($image_path);
	while ($image = readdir($temp)) {
		$suffix = strtolower(strstr($image, "."));
		if ($image!="." && $image!=".." && $image!='blank.gif' && in_array($suffix, $allowed_file_types) && !in_array($image, $ignored_images)) {
	      $all_images[] = $image;
	    }
	}	
	echo "
			<form name='node_info' method='post' action='$formaction'>
				<table align='center' cellpadding='0' cellspacing='0' width='400'>
				    <tr>
				        <td width='1%' class='tbl' style='white-space:nowrap'>" . $locale['tnp210'] . "</td>
				        <td class='tbl'><input type='text' name='node_name' value='$node_name' class='textbox' style='width:250px;'></td>
				    </tr>
				    <tr>
				        <td width='1%' class='tbl' style='white-space:nowrap'>" . $locale['tnp211'] . "</td>
				        <td class='tbl'><input type='text' name='node_url' value='$node_url ' class='textbox' style='width:250px;'></td>
				    </tr>
				    <tr>
				        <td width='1%' class='tbl' style='white-space:nowrap'>" . $locale['tnp219'] . "</td>
				        <td class='tbl'><input type='text' name='node_position' value='$node_position ' class='textbox' style='width:250px;'></td>
				    </tr>				    
				    <tr>
				        <td width='1%' class='tbl' style='white-space:nowrap'>" . $locale['tnp212'] . "</td>
				        <td class='tbl'><select name='node_visibility' class='textbox'>
				        $access_opts</select></td>
				    </tr>
				    <tr>
   				        <td width='1%' class='tbl' style='white-space:nowrap'>" . $locale['tnp213'] . "</td>
				    	<td class='tbl'>
	  					<select name='open_img' class='textbox' onChange=\"document.open_img_prv.src = '$image_path/' + document.node_info.open_img.options[document.node_info.open_img.selectedIndex].value;\">
						<option value='blank.gif' selected>".$locale['tnp218']."</option>\n";
    while (list ($key, $image) = each($all_images)) {	
		if ($open_img==$image) {
		echo "
						<option value='".$image."' selected>".$image."</option>\n";
		} else {
		echo "
						<option value='".$image."'>".$image."</option>\n";
		}

	}
	reset($all_images);
	echo "
						</select>\n
						&nbsp;".$locale['tnp214']."&nbsp;<img name='open_img_prv' src='$image_path/".($open_img ? $open_img : "blank.gif")."' border=0>		    
					</tr>
				    <tr>
   				        <td width='1%' class='tbl' style='white-space:nowrap'>" . $locale['tnp217'] . "</td>
				    	<td class='tbl'>
	  					<select name='closed_img' class='textbox' onChange=\"document.closed_img_prv.src = '$image_path/' + document.node_info.closed_img.options[document.node_info.closed_img.selectedIndex].value;\">\n
                        <option value='blank.gif' selected>".$locale['tnp218']."</option>\n";
    while (list ($key, $image) = each($all_images)) {	
		if ($closed_img==$image) {
		echo "
						<option value='".$image."' selected>".$image."</option>\n";
		} else {
		echo "
						<option value='".$image."'>".$image."</option>\n";
		}

	}	
	echo "
						</select>\n
						&nbsp;".$locale['tnp214']."&nbsp;<img name='closed_img_prv' src='$image_path/".($closed_img ? $closed_img : "blank.gif")."' border=0>		    
					</tr>					
				    <tr>
				        <td width='1%' class='tbl' style='white-space:nowrap'>" . $locale['tnp215'] . "</td>\n";

	if ($node_open){
		echo "
						<td class='tbl'><input type='checkbox' name='node_open' value='1' class='textbox' checked></td>\n";
	}else{
		echo "
						<td class='tbl'><input type='checkbox' name='node_open' value='1' class='textbox'></td>\n";
	}
	echo "
				    </tr>
				    <tr>
				        <td align='center' colspan='2' class='tbl'>
				        <input type='hidden' name='node_parent' value='$node_parent'>
				        
				        <input type='submit' name='save_node' value='" . $locale['tnp220'] . "' class='button'>&nbsp;&nbsp;";
    if (isset($node_id) && isNum($node_id)){
		echo "   
                        <a href='" . FUSION_SELF . "?action=delete_node&amp;node_id=" . $node_id . "' onclick='return confirmation(\"$node_name\", \"" . $locale['tnp240'] . "\");'>
						<input type='button' name='delete_node' value='" . $locale['tnp224'] . "' class='button'>
						</a>\n";
	}
	echo "
						</td>
				    </tr>
	   			</table>
			</form>\n";
	closetable();
} elseif (isset($action) && $action == "moveup") {

	$old_node_data = dbarray(dbquery("SELECT * FROM ".DB_PREFIX."tree_navigation_panel WHERE node_position='$node_position'"));
	$node_data = dbarray(dbquery("SELECT * FROM ".DB_PREFIX."tree_navigation_panel WHERE node_id='$node_id'"));
	
	$result = dbquery("UPDATE ".DB_PREFIX."tree_navigation_panel SET node_position='".$old_node_data['node_position']."', node_parent='".$old_node_data['node_parent']."', node_id='0' WHERE node_id='".$node_data['node_id']."'");
	$result = dbquery("UPDATE ".DB_PREFIX."tree_navigation_panel SET node_position='".$node_data['node_position']."', node_parent='".$node_data['node_parent']."', node_id='".$node_data['node_id']."' WHERE node_id='".$old_node_data['node_id']."'");
	$result = dbquery("UPDATE ".DB_PREFIX."tree_navigation_panel SET node_id='".$old_node_data['node_id']."' WHERE node_id='0'");
	redirect(FUSION_SELF);
	
} elseif (isset($action) && $action == "movedown") {

	$old_node_data = dbarray(dbquery("SELECT * FROM ".DB_PREFIX."tree_navigation_panel WHERE node_position='$node_position'"));
	$node_data = dbarray(dbquery("SELECT * FROM ".DB_PREFIX."tree_navigation_panel WHERE node_id='$node_id'"));
	
	$result = dbquery("UPDATE ".DB_PREFIX."tree_navigation_panel SET node_position='".$old_node_data['node_position']."', node_parent='".$old_node_data['node_parent']."', node_id='0' WHERE node_id='".$node_data['node_id']."'");
	$result = dbquery("UPDATE ".DB_PREFIX."tree_navigation_panel SET node_position='".$node_data['node_position']."', node_parent='".$node_data['node_parent']."', node_id='".$node_data['node_id']."' WHERE node_id='".$old_node_data['node_id']."'");
	$result = dbquery("UPDATE ".DB_PREFIX."tree_navigation_panel SET node_id='".$old_node_data['node_id']."' WHERE node_id='0'");
	redirect(FUSION_SELF);

}else{
    echo "<table align='center' cellpadding='0' cellspacing='1'  class='tbl-border'>\n";
    $result = dbquery("SELECT * FROM " . DB_PREFIX . "tree_navigation_panel");
	if (dbrows($result) == 0) {
	    echo "<tr><td align='center' class='tbl1'>" . $locale['tnp201'] . "<br>\n";	
	    echo "<a href='".FUSION_SELF."?action=add_node'><br><span class='button'>&nbsp;".$locale['tnp202']."&nbsp;</span></td></tr>\n";
	}else{ 
	    echo "<tr><td class='tbl1'>\n";	  
	    $menu  = new HTML_TreeMenu();
		$result = dbquery("SELECT * FROM " . DB_PREFIX . "tree_navigation_panel WHERE node_parent = 0 ORDER BY node_position ASC");
		while ($data = dbarray($result)){ 
		  $menu->addItem(buildTree($data['node_id']));        
		}
		$position_data = dbarray(dbquery("SELECT MAX(node_position) as last_position FROM " . DB_PREFIX . "tree_navigation_panel WHERE node_parent = 0"));
		$new_node_position = $position_data['last_position']+'1';		
        $menu->addItem(new HTML_TreeNode(array('text' => $locale['tnp216'], 'link' => FUSION_SELF."?action=add_node&node_parent=0&node_position=$new_node_position", 'icon' => 'add.gif')));
	    $treeMenu = &new HTML_TreeMenu_DHTML($menu, array('images' => $image_path , 'defaultClass' => 'treeMenuDefault'));
		$treeMenu->printMenu();
		echo "</td><td class='tbl1'>\n";
		echo "<table align='center' cellpadding='0' cellspacing='1'  class='tbl-border'>";
			
		$all_positions_result = dbquery("SELECT node_position FROM " . DB_PREFIX . "tree_navigation_panel ORDER BY node_position");
		while ($data = dbarray($all_positions_result)){
		 	   $all_positions[] = $data['node_position'];
		}

		$last_postion = dbarray(dbquery("SELECT MAX(node_position) as last_position FROM " . DB_PREFIX . "tree_navigation_panel"));
		$result = dbquery("SELECT * FROM " . DB_PREFIX . "tree_navigation_panel ORDER BY node_position ASC");
		$i = 0;
		while ($data = dbarray($result)){
			$i++;
			$indent_times = strlen($data['node_position']);
			$indent = str_repeat('&nbsp;&nbsp;', $indent_times );
			if ( $indent_times == "1" ) $indent = "";
			if ( $last_postion['last_position'] != $data['node_position']) $down = $all_positions[$i];
			echo "
			<tr>
				<td class='tbl1'>$indent
					<b>".$data['node_name']."</b>
				</td>
				<td align='center' width='1%' class='tbl2' style='white-space:nowrap'>"
						.$data['node_position']."
				</td>
				<td align='center' width='1%' class='tbl1' style='white-space:nowrap'>\n";
			if ( dbrows($result) == '1' ){
			    echo '&nbsp';
			}else{
				if ( $data['node_position'] == '1' )
					echo "<a href='".FUSION_SELF."?action=movedown&amp;node_position=$down&amp;node_id=".$data['node_id']."'><img src='".THEME."images/down.gif' alt='".$locale['tnp251']."' title='".$locale['tnp251']."' style='border:0px;'></a>\n";					   
				else if ( $last_postion['last_position'] == $data['node_position']){
					echo "<a href='".FUSION_SELF."?action=moveup&amp;node_position=$up&amp;node_id=".$data['node_id']."'><img src='".THEME."images/up.gif' alt='".$locale['tnp250']."' title='".$locale['tnp250']."' style='border:0px;'></a>\n"; 
				}else{
					echo "<a href='".FUSION_SELF."?action=moveup&amp;node_position=$up&amp;node_id=".$data['node_id']."'><img src='".THEME."images/up.gif' alt='".$locale['tnp250']."' title='".$locale['tnp250']."' style='border:0px;'></a>\n";
					echo "<a href='".FUSION_SELF."?action=movedown&amp;node_position=$down&amp;node_id=".$data['node_id']."'><img src='".THEME."images/down.gif' alt='".$locale['tnp251']."' title='".$locale['tnp251']."' style='border:0px;'></a>\n";		  
				}
			}
			echo "
					</td>
				</tr>\n";
	  		$up = $data['node_position'];
	    }
		echo "</table>\n";	    
		echo "</td></tr>";
		
	}

	echo "</table>\n";	
}
function &buildTree($id,$type='tree') {
	global   $db_prefix, $locale ;
	$parent_data = dbarray(dbquery("SELECT * FROM " . DB_PREFIX . "tree_navigation_panel WHERE node_id = $id ORDER BY node_position ASC"));
	if ($parent_data['open_img'] == 'blank.gif')	$parent_data['open_img']= '';
	if ($parent_data['closed_img'] == 'blank.gif')	$parent_data['closed_img']= ''; 
	$node = &new HTML_TreeNode(array('text' => $parent_data['node_name'], 'link' => FUSION_SELF."?action=edit_node&node_id=".$parent_data['node_id'], 'icon' => $parent_data['open_img'], 'expandedIcon' => $parent_data['closed_img'], 'expanded' => $parent_data['node_open'] ));

	$result = dbquery("SELECT * FROM " . DB_PREFIX . "tree_navigation_panel WHERE node_parent = ".$parent_data['node_id']." ORDER BY node_position ASC");
	while($data = dbarray($result)) {
	    $a_parent = dbrows(dbquery("SELECT * FROM " . DB_PREFIX . "tree_navigation_panel WHERE node_parent = ".$data['node_id']." ORDER BY node_position ASC"));
	    if ($a_parent > 0) {
	        $child_node = &buildTree($data['node_id']);            
	    } else {
			if ($data['open_img'] == 'blank.gif')	$data['open_img']= '';
			if ($data['closed_img'] == 'blank.gif')	$data['closed_img']= ''; 		      
	    	$child_node = &new HTML_TreeNode(array('text' => $data['node_name'], 'link' => FUSION_SELF."?action=edit_node&node_id=".$data['node_id'], 'icon' => $data['open_img'], 'expandedIcon' => $data['closed_img'], 'expanded' => $data['node_open']));
        	$last_child_position = dbarray(dbquery("SELECT MAX(node_position) as last_position FROM " . DB_PREFIX . "tree_navigation_panel WHERE node_parent = ".$data['node_id'] ));
			if (empty($last_child_position['last_position'])){
				$new_node_position = $data['node_position'].'.1';
			}else{
			    $new_node_position =  getNext($last_child_position['last_position']);
			}
			$child_node->addItem(new HTML_TreeNode(array('text' => $locale['tnp216'], 'link' => FUSION_SELF."?action=add_node&node_parent=".$data['node_id']."&node_position=$new_node_position", 'icon' => 'add.gif')));
	    }
    	$node->addItem($child_node);
	}
	$last_child_position = dbarray(dbquery("SELECT MAX(node_position) as last_position FROM " . DB_PREFIX . "tree_navigation_panel WHERE node_parent = ".$parent_data['node_id'] ));
	if (empty($last_child_position['last_position'])){
		$new_node_position = $parent_data['node_position'].'.1';
	}else{
	    $new_node_position = getNext($last_child_position['last_position']);
	}
    $node->addItem(new HTML_TreeNode(array('text' => $locale['tnp216'], 'link' => FUSION_SELF."?action=add_node&node_parent=".$parent_data['node_id']."&node_position=$new_node_position", 'icon' => 'add.gif')));
	return $node;
}
Function GetNext($c,$last=false)
{
	$d = explode(".",$c);
	if ($last){
		$d[ sizeof($d)-2 ] = $d[ sizeof($d)-2 ] +1;
		$d[ sizeof($d)-1 ] = 1;
	}else{
		$d[ sizeof($d)-1 ] = $d[ sizeof($d)-1 ] +1;    
	}

	return (implode(".", $d));
}
  require_once THEMES."templates/footer.php";
?>
